Summary:	W3C XML schema to C++ data binding compiler
Summary(pl.UTF-8):	Kompilator schematów W3C XML do wiązań danych C++
Name:		xsd
Version:	4.0.0
Release:	3
Group:		Development/Tools
# Exceptions permit otherwise GPLv2 incompatible combination with ASL-licensed Xerces
License:	GPL v2 with FLOSS exceptions
Source0:	http://www.codesynthesis.com/download/xsd/4.0/%{name}-%{version}+dep.tar.bz2
# Source0-md5:	ae64d7fcd258addc9b045fe3f96208bb
# Sent suggestion to upstream via e-mail 20090707
Patch0:		%{name}-3.3.0-xsdcxx-rename.patch
URL:		http://www.codesynthesis.com/products/xsd/
BuildRequires:	boost-devel
BuildRequires:	iconv
BuildRequires:	libcutl-devel >= 1.8.0
BuildRequires:	libstdc++-devel >= 6:4.2
BuildRequires:	libxsd-frontend-devel >= 2.0.0
BuildRequires:	m4
BuildRequires:	rpm-build >= 4.6
BuildRequires:	xerces-c-devel >= 3.0.0
Requires:	libcutl >= 1.8.0
Requires:	libxsd-frontend >= 2.0.0
Requires:	xerces-c-devel >= 3.0.0
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
CodeSynthesis XSD is an open-source, cross-platform W3C XML Schema to
C++ data binding compiler. Provided with an XML instance specification
(XML Schema), it generates C++ classes that represent the given
vocabulary as well as parsing and serialization code. You can then
access the data stored in XML using types and functions that
semantically correspond to your application domain rather than dealing
with intricacies of reading and writing XML.

%description -l pl.UTF-8
CodeSynthesis XSD to mający otwarte źródła wieloplatformowy kompilator
schematów W3C XML do wiązań danych C++. Na podstawie specyfikacji
instancji XML (schematu XML) generuje klasy C++ reprezentujące podany
słownik, a także kod analizujący i serializujący. Następnie można
odwoływać się do danych zapisanych w XML-u przy użyciu typów i funkcji
semantycznie odpowiadających działaniu aplikacji, bez zajmowania się
skomplikowaniem odczytu i zapisu XML-a.

%package apidocs
Summary:	API documentation files for XSD
Summary(pl.UTF-8):	Dokumentacja API XSD
Group:		Documentation
BuildArch:	noarch

%description apidocs
This package contains API documentation for XSD.

%description apidocs -l pl.UTF-8
Dokumentacja API XSD.

%prep
%setup -q -n %{name}-%{version}+dep
cd xsd
%patch0 -p1
cd ..

echo 'libxsd_frontend_installed := y' > xsd/build/import/libxsd-frontend/configuration-dynamic.make

%build
%{__make} \
	CXX="%{__cxx}" \
	CPPFLAGS="%{rpmcppflags}" \
	CXXFLAGS="%{rpmcxxflags}" \
	LDFLAGS="%{rpmldflags}" \
	EXTERNAL_LIBCUTL=y \
	verbose=1

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	install_prefix="$RPM_BUILD_ROOT%{_prefix}" \
	EXTERNAL_LIBCUTL=y

# Split API documentation to -doc subpackage.
rm -rf apidocdir
install -d apidocdir
%{__mv} $RPM_BUILD_ROOT%{_docdir}/xsd/*.{xhtml,css} apidocdir/
%{__mv} $RPM_BUILD_ROOT%{_docdir}/xsd/cxx/ apidocdir/
%{__mv} $RPM_BUILD_ROOT%{_docdir}/xsd/ docdir/

# Convert to utf-8.
for file in docdir/NEWS; do
	%{__mv} $file timestamp
	iconv -f ISO-8859-1 -t UTF-8 -o $file timestamp
	touch -r timestamp $file
done

# Rename binary to xsdcxx to avoid conflicting with mono-web package.
# Sent suggestion to upstream via e-mail 20090707
# they will consider renaming in 4.0.0
%{__mv} $RPM_BUILD_ROOT%{_bindir}/xsd $RPM_BUILD_ROOT%{_bindir}/xsdcxx
%{__mv} $RPM_BUILD_ROOT%{_mandir}/man1/xsd.1 $RPM_BUILD_ROOT%{_mandir}/man1/xsdcxx.1

# Remove duplicate docs.
%{__rm} -r $RPM_BUILD_ROOT%{_docdir}/libxsd

# Remove Microsoft Visual C++ compiler helper files.
%{__rm} -r $RPM_BUILD_ROOT%{_includedir}/xsd/cxx/compilers

# Remove redundant PostScript files that rpmlint grunts about not being UTF8
# See: https://bugzilla.redhat.com/show_bug.cgi?id=502024#c27
# for Boris Kolpackov's explanation about those
find apidocdir -name "*.ps" | xargs %{__rm}
# Remove other unwanted crap
find apidocdir -name "*.doxygen" \
            -o -name "makefile" \
            -o -name "*.html2ps" | xargs %{__rm}

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc docdir/*
%attr(755,root,root) %{_bindir}/xsdcxx
%{_includedir}/xsd
%{_mandir}/man1/xsdcxx.1*

%files apidocs
%defattr(644,root,root,755)
%doc apidocdir/*
%changelog
* Sun Feb 18 2024 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/xsd.git;a=log;h=master

* Sun Feb 18 2024 Jakub Bogusz <qboosh@pld-linux.org> 185e076
- adjusted to use system libcutl and libxsd-frontend; release 3

* Sun Feb 28 2021 Jan Rękorajski <baggins@pld-linux.org> 5fffde3
- unconditional noarch subpackages

* Fri Nov 24 2017 Jakub Bogusz <qboosh@pld-linux.org> a1fd048
- -fpermissive also for debug builds; use __rm macro

* Tue Nov 07 2017 Jan Rękorajski <baggins@pld-linux.org> 0428555
- release 2 (by relup.sh)

* Sun Nov 15 2015 Jan Rękorajski <baggins@pld-linux.org> 2440df3
- updated to 4.0.0

* Sun Jun 07 2015 Elan Ruusamäe <glen@delfi.ee> 2ed7ef0
- boost rebuild
- release 13 (by relup.sh)

* Sun May 03 2015 Jan Rękorajski <baggins@pld-linux.org> 67b1ea6
- x32 rebuild
- release 12 (by relup.sh)

* Tue Feb 17 2015 Jan Rękorajski <baggins@pld-linux.org> e5f57df
- rebuild with boost 1.57.0
- release 11 (by relup.sh)

* Sat Oct 25 2014 Jan Rękorajski <baggins@pld-linux.org> 2d2e2e0
- rebuild with boost 1.56.0
- release 10 (by relup.sh)

* Thu Apr 03 2014 Elan Ruusamäe <glen@delfi.ee> fce0eb0
- noarch apidocs

* Sun Feb 02 2014 Jan Rękorajski <baggins@pld-linux.org> 1121ce0
- - rebuild with boost 1.55.0
- release 8 (by relup.sh)

* Mon Jul 08 2013 Jan Rękorajski <baggins@pld-linux.org> b2712b4
- release 7 (by relup.sh)

* Sun Jul 07 2013 Jan Rękorajski <baggins@pld-linux.org> a56002e
- release 6 (by relup.sh)

* Wed Sep 19 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> 632fae4
- release 5 (by relup.sh)

* Thu Jul 12 2012 Jan Rękorajski <baggins@pld-linux.org> e53c49c
- More fixes for boost 1.50
Release 4

* Wed Jul 11 2012 Jan Rękorajski <baggins@pld-linux.org> f1f9722
- Added patches for gcc 4.7 and boost 1.50

* Wed Jul 11 2012 Jan Rękorajski <baggins@pld-linux.org> e51dd7c
- Attempt to fix filesystem V2 removal in boost 1.50

* Wed Jul 11 2012 Jan Rękorajski <baggins@pld-linux.org> 58ea235
- Fix building with gcc 4.7

* Sun Mar 11 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> 5b711e5
- release 3

* Mon May 09 2011 Jakub Bogusz <qboosh@pld-linux.org> 9cd009e
- pl
- force boost::filesystem v2 for now
- release 2 (boost upgrade rebuild)

